<template>
  <base-page :loading="loading" title="Task Manager App">
    <template v-slot:content>
      <ul>
        <li>Projects: {{ projects.length }}</li>
        <li>Persons: {{ persons.length }}</li>
        <li>Tasks: {{ tasks.length }}</li>
        <li>Completed tasks: {{ completedTasks }}</li>
        <li>Uncompleted tasks: {{ unCompletedTasks }}</li>
        <li>Uncompleted tasks over deadline: {{ overDeadline }}</li>
      </ul>
    </template>
  </base-page>
</template>

<script>
import BasePage from "../components/BasePage.vue";
import db from "../utilities/db";
import { isPast } from "../utilities/dateFunctions.js";

export default {
  components: { BasePage },

  data() {
    return {
      loading: true,
      tasks: [],
      persons: [],
      projects: [],
    };
  },
  created() {
    const promises = [
      db.get("js4tasks").then((data) => {
        this.tasks = data;
      }),
      db.get("js4persons").then((data) => {
        this.persons = data;
      }),
      db.get("js4projects").then((data) => {
        this.projects = data;
      }),
    ];
    Promise.all(promises).then(() => {
      this.loading = false;
    });
  },
  computed: {
    completedTasks() {
      return this.tasks.filter((task) => task.completed).length;
    },
    unCompletedTasks() {
      return this.tasks.length - this.completedTasks;
    },
    overDeadline() {
      return this.tasks.filter((task) => {
        return !task.completed && isPast(task.date);
      }).length;
    },
  },
};
</script>
